<script setup lang="ts">
import { ref, defineProps, onMounted } from 'vue'
import { uselistnamepayStore } from '@/stores/listnamepay'
import { loginData, type User } from '@/types/User'
import CheckInOut from '../checkInOut/CheckInOut.vue'
import ListNamePay from './ListNamePay.vue';
import type { Listnamepay } from '@/types/Listnamepay';
import Payback from '@/service/pay';
const listnamepayStore = uselistnamepayStore()
const listNamepay = uselistnamepayStore()
const props = defineProps<{

  listnamepays: Listnamepay[]
}>()

function convertUserToListnamepay(user: User): Listnamepay {
  return {
    id: user.id,
    name: user.fullName,
    status:'',
    roles: user.roles,
    salary: user.timework * 330, // แก้ไขคำนวณเงินเดือนตามเวลาการทำงาน
    workhours: user.timework,
    date: new Date()
  };
}



// อัปจากหลังบ้านมาหน้าบ้าน ++++++++
// onMounted(() => {
//   Payback.getPays().then((response) => {
//     const data = response.data; 
//     listNamepay.listnamepay = data;
//     console.log(listNamepay.listnamepay)
//   }).catch((error) => {
//     console.error('Error fetching pays:', error);
//   });
// });



// format เวลา +++++++++++++++++++++++++
// const formatDate = (date: Date) => {
//     const options = { 
//       year: 'numeric' as const, 
//       month: 'long' as const, 
//       day: 'numeric' as const
//     };
//     return date.toLocaleDateString('en-US', options);
// }

const checkedStates = ref<{ [key: number]: boolean }>({})
const generateEmptyArray = (length: number, initialValue: any) =>
  Array.from({ length }, () => initialValue)

const idCount = 999

const Timein = ref<string[]>(generateEmptyArray(idCount, '-'))
const Timeout = ref<string[]>(generateEmptyArray(idCount, '-'))
const workhour = ref<number[]>(generateEmptyArray(idCount, 0))
const Role = ref<string[]>(generateEmptyArray(idCount, ''))
const totalWorkHours = ref<number[]>(generateEmptyArray(idCount, 0))
const Status = ref<string[]>(generateEmptyArray(idCount, 'ไม่อนุมัติ'))
const LM = ref<Listnamepay[]>([])

function Openshow(employee: Listnamepay) {
  const index = props.listnamepays.findIndex((user) => user.id === employee.id)

  if (index !== -1) {
    if (checkedStates.value[employee.id!]) {
      Role.value[index] = employee.roles
      workhour.value[index] = employee.workhours


      
     
      totalWorkHours.value[index] = parseFloat(( employee.workhours* 330).toFixed(0))


      Status.value[index] = 'อนุมัติ'
    } else {
      workhour.value[index] = 0
      Role.value[index] = '-'
      totalWorkHours.value[index] = 0
      Status.value[index] = 'ไม่อนุมัติ'
    }
  }
}

function StatusColor(status: string): string {
  return status === 'อนุมัติ' ? 'green' : 'red'
}

const dialog = ref()
</script>

<template>
  <v-card>
    <v-table fixed-header height="500px" style="overflow: auto">
      <thead>
        <tr>
          <th class="text-center">ID</th>
          <th class="text-center">FullName</th>
          <th class="text-center">WorkHours</th>
          <th class="text-center">Roles</th>
          <th class="text-center">Status</th>
          <th class="text-center">Salary</th>
          <th class="text-center">Date</th>
          <th class="text-center"></th>
          <th class="text-center"></th>
        </tr>
      </thead>
      <tbody>
        <tr v-for="(item, index) in listNamepay.listnamepay" :key="index">
          <td class="text-center">{{ item.id }}</td>
          <td class="text-center">{{ item.name }}</td>
          <td class="text-center">{{  workhour[index]}}</td>

          <td class="text-center">{{ (Role[index] || '-') }}</td>
          <td class="text-center" :style="{ color: StatusColor(Status[index]) }">{{ item.status=Status[index] }}</td>
          <td class="text-center">{{ item.salary = totalWorkHours[index] }} ฿</td>
          <td class="text-center">{{ item.date }}</td>
          <td class="text-center">
            <div class="text-center">
              <v-dialog v-model="dialog" max-width="400" persistent>
                <template v-slot:activator="{ props: activatorProps }">
                  <v-btn v-bind="activatorProps">
                    <v-icon icon="mdi-delete-outline"></v-icon>
                  </v-btn>
                </template>
                <v-card prepend-icon="mdi-head-dots-horizontal" title="Are you sure?">
                  <template v-slot:actions>
                    <v-spacer></v-spacer>
                    <v-btn @click="dialog = false">Disagree</v-btn>
                    <v-btn @click="listNamepay.deleteEmployee(item.id!)">Agree</v-btn>
                  </template>
                </v-card>
              </v-dialog>
            </div>
          </td>
          <td class="text-center">
            <div>
              <input type="checkbox" v-model="checkedStates[item.id!]" @change="() => Openshow(item)" />
            </div>
          </td>
        </tr>
      </tbody>
    </v-table>
  </v-card>
</template>

<style scoped></style>
